Library ACLCtl10;

uses
  OS2Def, PmWin,
  SysUtils, 
  Forms, Dialogs,
  RichTextView;

function ACLInitCtl: BOOL; APIENTRY;
begin
  try
    Application.Create;
    result := true;
  except
    On e: exception do
    begin
      // can't use Sibyl functions like ShowMessage if app didn't init
      WinMessageBox( HWND_DESKTOP,
                     HWND_DESKTOP,
                     cstring( e.Message ),
                     'ACLInitCtl Error',
                     0,
                     MB_OK + MB_ERROR + MB_MOVEABLE );
      result := false;
    end;
  end;
end;


function ACLCreateRichTextView( Parent: HWND;
                             X: longint;
                             Y: longint;
                             Width: longint;
                             Height: longint;
                             Visible: LONGBOOL;
                             ): longint; 
{
 // manually reversed arguments... 
function ACLCreateRichTextView( Visible: LONGBOOL;
                             Height: longint;
                             Width: longint;
                             Y: longint;
                             X: longint;
                             Parent: HWND;
                             ): longint; 
}
var
  rtv: TRichTextView;
begin
{
  ShowMessage( 'ACLCreateRichTextView '
               + IntToStr( X)
               + ','
               + IntToStr( Y ) 
               + ', parent: ' 
               + IntToStr( longint( Parent ) )
               + ', visible: '
               + IntToStr( longint( Visible ) ) );
}
  rtv := TRichTextView.Create( nil );
  rtv.Visible := false;
  rtv.SetWindowPos( X, Y, Width, Height );

  RTV.Perform(CM_PARENTFONTCHANGED,0,0);
  RTV.Perform(CM_PARENTPENCOLORCHANGED,0,0);
  RTV.Perform(CM_PARENTCOLORCHANGED,0,0);

  RTV.CreateWindow;

  WinSetParent( rtv.Handle, Parent, true );
  if Visible then RTV.SHow;
  result := longint( rtv );
end;

procedure ACLRTVClearText( c: longint ); APIENTRY;
begin
  TRichTextView( c ).Clear;
end;

{
procedure ACLRTVAddText( c: longint;
                         text: pchar ); APIENTRY;
}
procedure ACLRTVAddText( text: pchar;
                         c: longint ); APIENTRY;
begin
  TRichTextView( c ).AddText( Text );
end;

{
procedure ACLRTVAddParagraph( c: longint;
                              text: pchar ); APIENTRY;
}
procedure ACLRTVAddParagraph( text: pchar;
                              c: longint
                               ); APIENTRY;
begin
  TRichTextView( c ).AddParagraph( Text );
end;

procedure ACLRTVAddSelectedParagraph( text: pchar;
                                      c: longint ); APIENTRY;
begin
  TRichTextView( c ).AddSelectedParagraph( Text );
end;

function ACLRTVGetWindow( c: longint ): HWND; APIENTRY;
begin
  result := TRichTextView( c ).Handle;
end;

Exports
  ACLInitCtl index 1,

  ACLCreateRichTextView index 2,

  ACLRTVClearText index 3,
  ACLRTVAddText index 4,
  ACLRTVAddParagraph index 5,
  ACLRTVAddSelectedParagraph index 6,
  ACLRTVGetWindow index 7;

begin

end.